//返回值:
//0         成功
//-3001     参数非json
//-3002     参数格式错误
//-3003		参数错误

//********************************************** 全 局 变 量 ************************************************************
var pub_注册码表="注册码"
var pub_注册码时长 = array("天卡"=1,"周卡"=7,"月卡"=30,"季卡"=90,"年卡"=365)
var pub_注册码价格 = array("天卡"=2,"周卡"=14,"月卡"=60,"季卡"=150,"年卡"=700)
//********************************************** 逻 辑 函 数 ************************************************************
功能 管理端_查询指定页注册码(查询信息,&返回arr)//返回指定页数注册码.
    //查询信息:{"page":"1"}	取第一页 若为空串 则默认取第一页
    //返回值:
    //{"Ppage":"50","Npage":"1",regcode:{"0":{"卡号":"ADSAS",..},"1":{"卡号":"ASDASD",..}}}
    //{"Ppage":"50","Npage":"1",regcode:{"0":{"卡号":"ADSAS",..},"1":{"卡号":"ASDASD",..}}}
    //SELECT *, rowid FROM "注册码" LIMIT 50 OFFSET i*50
    var arr,sql,retarr,ret
    如果(!是否json(查询信息))
        返回 -3001
    结束
    arr = json转数组(查询信息)
    如果(arr == null)
        返回 -3002
    结束
    如果(!关联数组键是否存在(arr,"page"))
        返回 -3003
    结束
    如果(转整型(arr["page"]) <= 0)
        //取第一页
        sql = 字符串格式化("SELECT *, rowid FROM %s LIMIT 50 OFFSET %s;",pub_注册码表,0)
    否则
        //取指定页
        sql = 字符串格式化("SELECT *, rowid FROM %s LIMIT 50 OFFSET %s;",pub_注册码表,(转整型(arr["page"]) - 1)*50)
    结束
    ret = sqlite数据库执行返回数组(pub_数据库名,sql,retarr)
    如果(!ret)
        //查询失败
        返回 -1
    否则
        如果(数组大小(retarr) == 0)
            //无结果
            返回arr = array()
            返回 0
        否则
            //查询成功
            返回arr = retarr
            返回 0
        结束
    结束
结束
功能 管理端_查询注册码数量(&返回数量)
    var json = 数组转json(array("查询信息"=array(),"查询条件"=array()))
    var retjson
    var ret = 数据库_查询(pub_数据库名,pub_注册码表,json,retjson)
    var arr = json转数组(retjson)
    返回数量 = 数组大小(arr)
    返回 0
结束
功能 管理端_查询注册码信息(注册码信息json,&返回arr)//待测试。。查询指定条件的
    //注册码信息：{"实际卡号":{"0":"卡面额","1":"卡类型"},"不存在卡号":{"0":"卡面额","1":"卡类型"}} 结构不对也会返回空数组
    //返回arr:{"实际卡号":{"卡面额":"30","卡类型":"月卡"},"不存在卡号":{}}
    var arr,arrlen,retarr=array()
    如果(!是否json(注册码信息json))
        返回 -3001
    结束
    arr = json转数组(注册码信息json)
    如果(arr == null)
        返回 -3002
    结束
    arrlen = 数组大小(arr) 
    遍历(变量 i = 0 ; i < arrlen ; i ++)
        var 注册码信息,注册码,查询json = array(),返回Json,ret
        关联数组获取元素(arr,i,注册码信息,注册码)
        如果(!是否数组(注册码信息))
            关联数组插入元素(retarr,array(),注册码,i)
        结束
        //开始构建查询json
        查询json["查询条件"] = array("注册码"=注册码)//这里与表结构一致才行
        查询json["查询信息"] = 注册码信息
        ret = 数据库_查询(pub_数据库名,pub_注册码表,数组转json(查询json),返回Json)
        如果(ret == 0)
            关联数组插入元素(retarr,json转数组(返回Json),注册码,i)
        否则
            关联数组插入元素(retarr,array(),注册码,i)
        结束
    结束
    返回arr = retarr
    返回 0
结束
功能 管理端_修改注册码信息(注册码信息json,&返回arr)//提供全部信息修改或者修改指定部分的
    //注册码信息:{"注册码A":{"状态":"1"},"注册码B":{"状态":"2"}}
    var arr,arrlen,retarr=array()
    如果(!是否json(注册码信息json))
        返回 -3001
    结束
    arr = json转数组(注册码信息json)
    如果(arr == null)
        返回 -3002
    结束
    arrlen = 数组大小(arr)
    遍历(变量 i = 0; i < arrlen ; i ++)
        var 注册码信息,注册码,更新json = array("更新条件"="","更新信息"=""),ret
        关联数组获取元素(arr,i,注册码信息,注册码)
        如果(!是否数组(注册码信息))
            关联数组插入元素(retarr,"格式错误",注册码,i)
            继续
        结束
        //判断是否更改卡类型
        //如果(关联数组键是否存在(注册码信息,"卡类型"))
        //   
        //结束
        //****其他
        //开始构建修改信息
        更新json["更新条件"] = array("注册码"=注册码)
        更新json["更新信息"] = 注册码信息
        ret = 数据库_更新(pub_数据库名,pub_注册码表,数组转json(更新json))
        如果(ret == 0)
            关联数组插入元素(retarr,"OK",注册码,i)
        否则
            //记录日志
            关联数组插入元素(retarr,"原因码:" & ret,注册码,i)
        结束
    结束
    返回arr = retarr
    返回 0
结束

功能 管理端_删除注册码信息(注册码信息json,&返回arr)//按条件删除。
    //注册码信息json:{"x":"注册码卡号","xx":"注册码卡号",....}
    var arr,arrlen,retarr=array()
    如果(!是否json(注册码信息json))
        返回 -3001
    结束
    arr = json转数组(注册码信息json)
    如果(arr == null)
        返回 -3002
    结束
    arrlen = 数组大小(arr)
    遍历(变量 i = 0 ; i < arrlen ; i ++)
        var 注册码,删除json=array(),ret
        关联数组获取元素(arr,i,注册码)
        删除json["删除条件"]=array("注册码"=注册码)
        ret = 数据库_删除(pub_数据库名,pub_注册码表,数组转json(删除json))
        如果(ret == 0)
            关联数组插入元素(retarr,"OK",注册码,i)
        否则
            关联数组插入元素(retarr,"原因码:" & ret,i)
        结束
    结束
    返回arr = retarr
    返回 0
结束
功能 管理端_创建注册码信息(注册码信息json,&返回arr)
    //注册码信息json:{"天卡":100,"月卡":100}
    var arr,arrlen,retarr=array()
    如果(!是否json(注册码信息json))
        返回 -3001
    结束
    arr = json转数组(注册码信息json)
    如果(arr == null)
        返回 -3002
    结束
    arrlen = 数组大小(arr)
    遍历(变量 i = 0 ; i < arrlen ; i ++)
        //第一个循环遍历卡类型
        var 卡类型,数量,retarry=array()
        关联数组获取元素(arr,i,数量,卡类型)
        如果(关联数组键查找(pub_注册码时长,卡类型) == -1)
            //不存在该卡类型
            关联数组插入元素(retarr,"没有该卡类型",卡类型,i)
            继续
        结束
        如果(是否整型(数量) == false)
            关联数组插入元素(retarr,"数量类型错误",卡类型,i)
            继续
        结束
        //开始生成指定数量注册码
        遍历(变量 x = 0 ; x < 转整型(数量) ; x ++)
            var 注册码=sha512(私有_生成随机信息()&当前时间()),卡时长=pub_注册码时长[卡类型],卡面额=pub_注册码价格[卡类型],卡状态="0",制造者="admin",操作时间=当前时间(),备注="",插入json=array()
            //上面是初始化所有参数 下面开始插入数据
            插入json["插入信息"]=array("注册码" = 注册码,"卡时长" = 卡时长,"卡面额" = 卡面额,"卡状态" = 卡状态,"卡类型" = 卡类型,"制造者"=制造者,"操作时间"=操作时间,"备注" = 备注)
            var ret = 数据库_插入(pub_数据库名,pub_注册码表,数组转json(插入json))
            如果(ret == 0)
                关联数组插入元素(retarry,注册码,x)
            否则
                x --
            结束
        结束
        关联数组插入元素(retarr,retarry,卡类型,i)
    结束
    返回arr = retarr
    返回 0
结束





//**********************************************最 底 层 函 数*********************************************************
功能 私有_生成随机信息()
    var str=""
    遍历(var i = 0 ; i < 50 ; i ++)
        str = str & 字符串格式化("%c",随机数(33,126))
    结束
    返回 str
结束
