//返回值:
//0			成功
//-4000
//-4001		参数非JSON字符串
//-4002		参数无法转数组
//-4003		参数信息缺失
//-4004		参数信息非数组
//-4005		参数空数组
var pub_用户表="用户"

功能 管理端_获取账号信息(账号信息json,&返回arr)
    //账号信息json格式:
    //账号A获取指定信息,账号B获取全部信息:{"账号信息":{"账号A":{"x":"密码","xx":"权限"},"账号B":{}}}
    var arr,arrlen,retarr=array()
    如果(! 是否json(账号信息json))
        返回 -4001
    结束
    arr = json转数组(账号信息json)
    如果(arr == null)
        返回 -4002
    结束
    如果(! 关联数组键是否存在(arr,"账号信息"))
        返回 -4003
    结束
    如果(! 是否数组(arr["账号信息"]))
        返回 -4004
    结束
    arrlen = 数组大小(arr["账号信息"])
    如果(arrlen <= 0)
        返回 -4005
    结束
    //查询指定行
    遍历(变量 i = 0; i < arrlen; i++)
        var 账号信息,账号,len,查询json = array(),ret,retjson
        关联数组获取元素(arr["账号信息"],i,账号信息,账号)
        如果(!是否数组(账号信息))
            关联数组插入元素(retarr,"非数组",账号)
            继续
        结束
        len = 数组大小(账号信息)
        如果(len == 0)
            //取所有信息
            查询json["查询条件"]=array("账号"=账号)
            查询json["查询信息"]=array()
        否则
            //取指定信息
            查询json["查询条件"]=array("账号"=账号)
            查询json["查询信息"]=账号信息
        结束
        ret = 数据库_查询(pub_数据库名,pub_用户表,数组转json(查询json),retjson)
        如果(ret == 0)
            关联数组插入元素(retarr,json转数组(retjson),账号,i)
        否则
            关联数组插入元素(retarr,"原因码:" & ret,账号,i)
        结束
    结束
    返回arr = retarr
    返回 0
结束





功能 管理端_查询指定页账号(查询信息,&返回arr)//返回指定页数注册码.
    //查询信息:{"page":"1"}	取第一页 若为空串 则默认取第一页
    //SELECT *, rowid FROM "注册码" LIMIT 50 OFFSET i*50
    var arr,sql,retarr,ret
    如果(!是否json(查询信息))
        返回 -4001
    结束
    arr = json转数组(查询信息)
    如果(arr == null)
        返回 -4002
    结束
    如果(!关联数组键是否存在(arr,"page"))
        返回 -4003
    结束
    如果(转整型(arr["page"]) <= 0)
        //取第一页
        sql = 字符串格式化("SELECT *, rowid FROM %s LIMIT 50 OFFSET %s;",pub_用户表,0)
    否则
        //取指定页
        sql = 字符串格式化("SELECT *, rowid FROM %s LIMIT 50 OFFSET %s;",pub_用户表,(转整型(arr["page"]) - 1)*50)
    结束
    ret = sqlite数据库执行返回数组(pub_数据库名,sql,retarr)
    如果(!ret)
        //查询失败
        返回 -1
    否则
        如果(数组大小(retarr) == 0)
            //无结果
            返回arr = array()
            返回 0
        否则
            //查询成功
            返回arr = retarr
            返回 0
        结束
    结束
结束

功能 管理端_修改账号信息(账号信息json,&返回arr)//提供全部信息修改或者修改指定部分的
    //账号信息:{"账号1":{"状态":"1"},"账号2":{"状态":"2"}}
    var arr,arrlen,retarr=array()
    如果(!是否json(账号信息json))
        返回 -4001
    结束
    arr = json转数组(账号信息json)
    如果(arr == null)
        返回 -4002
    结束
    arrlen = 数组大小(arr)
    遍历(变量 i = 0; i < arrlen ; i ++)
        var 账号信息,账号,更新json = array("更新条件"="","更新信息"=""),ret
        关联数组获取元素(arr,i,账号信息,账号)
        如果(!是否数组(账号信息))
            关联数组插入元素(retarr,"格式错误",账号,i)
            继续
        结束
        //****其他
        //开始构建修改信息
        更新json["更新条件"] = array("账号"=账号)
        更新json["更新信息"] = 账号信息
        ret = 数据库_更新(pub_数据库名,pub_用户表,数组转json(更新json))
        如果(ret == 0)
            关联数组插入元素(retarr,"OK",账号,i)
        否则
            //记录日志
            关联数组插入元素(retarr,"原因码:" & ret,账号,i)
        结束
    结束
    返回arr = retarr
    返回 0
结束
功能 管理端_创建账号(账号信息json,&返回arr)
    //账号信息json:
    //用户账号:{"账号":"","密码":"","权限":2}	额外可选字段看表
    //代理账号:{"账号":"","密码":"","权限":1}	额外可选字段看表
    //管理账号:{"账号":"","密码":"","权限":0}	权限0即有全部权限
    
结束
功能 管理端_删除账号信息(账号信息json,&返回arr)//按条件删除。
    //账号信息json:{"x":"账号","xx":"账号",....}
    var arr,arrlen,retarr=array()
    如果(!是否json(账号信息json))
        返回 -4001
    结束
    arr = json转数组(账号信息json)
    如果(arr == null)
        返回 -4002
    结束
    arrlen = 数组大小(arr)
    遍历(变量 i = 0 ; i < arrlen ; i ++)
        var 账号,删除json=array(),ret
        关联数组获取元素(arr,i,账号)
        删除json["删除条件"]=array("账号"=账号)
        ret = 数据库_删除(pub_数据库名,pub_用户表,数组转json(删除json))
        如果(ret == 0)
            关联数组插入元素(retarr,"OK",账号,i)
        否则
            关联数组插入元素(retarr,"原因码:" & ret,i)
        结束
    结束
    返回arr = retarr
    返回 0
结束

功能 管理端_查询账号数量(&返回数量)
    var json = 数组转json(array("查询信息"=array(),"查询条件"=array()))
    var retjson
    var ret = 数据库_查询(pub_数据库名,pub_用户表,json,retjson)
    var arr = json转数组(retjson)
    返回数量 = 数组大小(arr)
    返回 0
结束