function _initial()
    sendtextmsg("云应用启动成功")
end

function _mainbutton()//主按钮 
    sendtextmsg("点击主按钮")
end

function _get(token,arg,ip)
    
    if(token == "32e09966be2765cbf47562f08c35c94d") //这里通过token做一个简单的权限验证
        var arr = jsontoarray(arg)
        if(arraysize(arr) > 0)
            var json
            select(arr["mode"])
                
                case "query"//查询数据 json格式 {"mode":"query","start":0,"len",0} start 数据位置起点,len数据位置长度
                var start,len
                var ret,sqlstr
                var where = ""
                if(arraykeyexists(arr,"where") && strlen(arr["where"]))
                    where = " where " & arr["where"] & " "
                end
                if(arraykeyexists(arr,"start") && arraykeyexists(arr,"len"))
                    start = arr["start"]
                    len = arr["len"]
                    sqlstr = "SELECT * FROM  regManager " & where & " limit " & start & "," & len
                elseif(arraykeyexists(arr,"start") && !arraykeyexists(arr,"len"))
                    start = arr["start"]
                    sqlstr = "SELECT * FROM  regManager " & where & " limit " & start
                elseif(!arraykeyexists(arr,"start") && arraykeyexists(arr,"len"))
                    len = arr["len"]
                    sqlstr = "SELECT * FROM  regManager " & where & " limit 0," & len
                else
                    sqlstr = "SELECT * FROM  regManager " & where
                end
                ret = sqlitesqljson("regtest.db",sqlstr,json)
                if(ret == 0)
                    return getlasterror(1)
                else
                    return json //返回json格式数据
                end
                
                case "page"//查询分页 json格式 {"mode":"page","pageCount":10,"pageIndex",0} pageCount 每个分页有多少条数据,pageIndex 当前分布位置
                var result = array()
                var sqlStr = "SELECT * FROM  regManager"
                if(arraykeyexists(arr,"where") && strlen(arr["where"]))
                    sqlStr = sqlStr & " where " & arr["where"]
                end
                if(arraykeyexists(arr,"pageCount") && arraykeyexists(arr,"pageIndex"))//
                    var pageCount = arr["pageCount"]
                    var pageIndex = arr["pageIndex"]
                    var ret_arr
                    var ret = sqlitesqlarray("regtest.db",sqlStr,ret_arr)
                    if(ret)
                        var size = arraysize(ret_arr)
                        var count = (size / pageCount)
                        var mod = size % pageCount
                        if(mod > 0)
                            count = count + 1
                        end
                        result["left"] = "共 " & size & " 条数据，每页 " & pageCount & " 条，共 " & count & " 页，当前为第 " & pageIndex & " 页"
                        result["right"] = count
                        result["debuginfo"] = arr
                        return arraytojson(result)
                    end
                    return getlasterror(1) & " " & sqlStr
                    //返回格式 {"left":"左侧信息","right":{"1":{}}}
                end
                return ""
                
                case "unbind"//解绑功能
                var ret_arr
                var sqlstr = strformat("update regManager set isbind='false' where regcode='%s';",arr["regcode"])
                var ret = sqlitesqlarray("regtest.db",sqlstr,ret_arr)
                var result = array()
                if(ret)
                    result["status"] = "ok"
                    result["msg"] = "解绑成功"
                否则
                    result["status"] = "fail"
                    result["msg"] = "解绑失败"
                end
                return arraytojson(result)
                
                case "frozen"//解绑功能
                var ret_arr
                if(arr["type"] == "frozen")
                    var sqlstr = strformat("update regManager set isFrozen='true' where regcode='%s';",arr["regcode"])
                    var ret = sqlitesqlarray("regtest.db",sqlstr,ret_arr)
                    var result = array()
                    if(ret)
                        result["status"] = "ok"
                        result["msg"] = "冻结成功"
                    else
                        result["status"] = "fail"
                        result["msg"] = "冻结失败"
                    end
                    return arraytojson(result)
                elseif(arr["type"] == "unfrozen")
                    var sqlstr = strformat("update regManager set isFrozen='false' where regcode='%s';",arr["regcode"])
                    var ret = sqlitesqlarray("regtest.db",sqlstr,ret_arr)
                    var result = array()
                    if(ret)
                        result["status"] = "ok"
                        result["msg"] = "解冻成功"
                    else
                        result["status"] = "fail"
                        result["msg"] = "解冻失败"
                    end
                    return arraytojson(result)
                end
            end
        end
        return filereadex("rc:test.html")
    end
end