// 此文件为注册码相关操作

// 创建数据库,此为测试示例,所以创建数据库使用代码创建,实际项目里,不建议这样做.
// 百宝云的虚拟桌面系统里有数据库管理,推荐大家在虚拟桌面里进行数据库的创建与字段修改操作.
功能 sql创建注册码数据库()
    变量 返回数组,ret
    ret = sqlite数据库执行返回数组("注册码数据库.db","create table IF NOT EXISTS 注册码管理表(序号 integer primary key autoincrement,项目名称,注册码名称,创建时间,激活时间,到期时间,机器码,绑定 DEFAULT '否',冻结 DEFAULT '否',卡类型,激活 DEFAULT '否',备注,IP,最后登陆时间,状态 DEFAULT '未使用',在线 DEFAULT '否',token,最后访问时间)",返回数组)//创建表
    如果(!ret)
        写注册码操作日志("创建表失败:"& 获取错误信息(1))
        返回 假
    否则
        返回 真
    结束
结束


// 生成注册码功能
功能 sql创建新注册码(类型,项目名称,注册码个数)
    变量 数据 = 0
    变量 统计总数sql语句 = 字符串格式化("select count(*) from 注册码管理表 where 项目名称='%s'",项目名称)
    sqlite数据库执行返回数组("注册码数据库.db",统计总数sql语句,数据)
    变量 总数 = 数据["0"]["count(*)"]
    变量 创建时间 = 当前时间()
    变量 返回数据 = 数组()
    遍历(变量 i = 0; i < 注册码个数; i++)
        变量 timestr = 获取系统时间()
        变量 md5str = md5(timestr)
        变量 retArray = null,inserText
        选择(类型)
            条件 "季卡"
            inserText = 字符串格式化("insert into 注册码管理表(注册码名称,卡类型,项目名称,创建时间) values('%s','季卡','%s','%s')",md5str,项目名称,创建时间)
            
            条件 "月卡"
            inserText = 字符串格式化("insert into 注册码管理表(注册码名称,卡类型,项目名称,创建时间) values('%s','月卡','%s','%s')",md5str,项目名称,创建时间)
            
            条件 "周卡"
            inserText = 字符串格式化("insert into 注册码管理表(注册码名称,卡类型,项目名称,创建时间) values('%s','周卡','%s','%s')",md5str,项目名称,创建时间)
            
            条件 "天卡"
            inserText = 字符串格式化("insert into 注册码管理表(注册码名称,卡类型,项目名称,创建时间) values('%s','天卡','%s','%s')",md5str,项目名称,创建时间)
        结束
        
        变量 ret = sqlite数据库执行返回json("注册码数据库.db",inserText,retArray)
        如果(!ret)
            写注册码操作日志("插入注册码["&md5str&"]失败,原因:"&获取错误信息(1))
        结束
    结束
    
    变量 sqlstr = 字符串格式化("select * from 注册码管理表 where 项目名称='%s'  limit %s,%s",项目名称,总数,注册码个数)
    变量 ret = sqlite数据库执行返回json("注册码数据库.db",sqlstr,返回数据)
    写注册码操作日志("生成的注册码为:"&返回数据)
    
    // 记录操作日志
    写操作日志("创建注册码功能","一共创建了 【"&注册码个数&"】 条类型为 【"&类型&"】 的注册码")
    返回 返回数据
结束

// 解绑注册码
功能 sql解绑注册码(regKey)
    变量 返回内容,ret
    变量 keyArr = 字符串转数组(regKey)
    遍历(变量 i = 0; i < 数组大小(keyArr); i++)
        变量 sqlstr = 字符串格式化("update 注册码管理表 set 绑定='否',机器码='' where 注册码名称='%s'",keyArr[i])
        ret = sqlite数据库执行返回json("注册码数据库.db",sqlstr,返回内容)
        // 记录操作日志
        写操作日志("解绑注册码",keyArr[i]&" 已解绑")
    结束
    
    返回 真
结束

// 解绑注册码
功能 sql客户端解绑注册码(regKey,机器码)
    变量 返回内容,ret
    变量 sqlstr = 字符串格式化("update 注册码管理表 set 绑定='否',机器码='' where 注册码名称='%s' and 机器码='%s'",regKey,机器码)
    ret = sqlite数据库执行返回json("注册码数据库.db",sqlstr,返回内容)
    // 记录操作日志
    写操作日志("客户端解绑注册码",regKey&" 客户端已解绑")
    
    返回 真
结束


// 冻结注册码
功能 sql冻结注册码(regKey)
    变量 返回内容,ret
    变量 keyArr = 字符串转数组(regKey)
    遍历(变量 i = 0; i < 数组大小(keyArr); i++)        
        变量 sqlstr = 字符串格式化("update 注册码管理表 set 冻结='是' where 注册码名称='%s'",keyArr[i])
        ret = sqlite数据库执行返回json("注册码数据库.db",sqlstr,返回内容)
        // 记录操作日志
        写操作日志("冻结注册码",keyArr[i]&" 被冻结")
    结束
    
    写注册码操作日志("冻结注册码"&regKey)
    返回 真
结束


// 解冻注册码
功能 sql解冻注册码(regKey)
    变量 返回内容,ret
    变量 keyArr = 字符串转数组(regKey)
    遍历(变量 i = 0; i < 数组大小(keyArr); i++)
        变量 sqlstr = ""
        sqlstr = 字符串格式化("update 注册码管理表 set 冻结='否' where 注册码名称='%s'",keyArr[i])
        ret = sqlite数据库执行返回json("注册码数据库.db",sqlstr,返回内容)
        // 记录操作日志
        写操作日志("解冻注册码",keyArr[i]&" 已解冻")
    结束
    
    写注册码操作日志("解冻注册码" & regKey)
    返回 真
结束

// 删除注册码
功能 sql删除注册码(regKey)
    变量 返回内容,ret
    变量 keyArr = 字符串转数组(regKey)
    遍历(变量 i = 0; i < 数组大小(keyArr); i++)
        变量 sqlstr = 字符串格式化("delete from 注册码管理表 where 注册码名称='%s'",keyArr[i])
        ret = sqlite数据库执行返回json("注册码数据库.db",sqlstr,返回内容)
        
        // 记录操作日志
        写操作日志("删除注册码",keyArr[i]&" 已删除")
    结束
    写注册码操作日志("删除注册码" & regKey)
    返回 真
结束

// sql续费注册码
功能 sql续费注册码(regKey,时长天数)
    变量 返回数组,ret
    变量 keyArr = 字符串转数组(regKey)
    遍历(变量 i = 0; i < 数组大小(keyArr); i++)
        变量 sqlstr = 字符串格式化("select * from 注册码管理表 where 注册码名称='%s'",keyArr[i])
        ret = sqlite数据库执行返回数组("注册码数据库.db",sqlstr,返回数组)
        如果(ret && 数组大小(返回数组) > 0)
            变量 end1Time1 = 返回数组[0]["到期时间"]
            
            // 记录操作日志
            写操作日志("续费注册码",keyArr[i]&" 续费了:"&时长天数&"天")
            
            // 判断当前的注册码是否为过期的注册码
            变量 当前的时间 = 当前时间()
            变量 是否更新状态 = 假
            如果(时间间隔("n",当前的时间,end1Time1) < 0)
                end1Time1 = 当前的时间
                是否更新状态 = 真
            结束
            
            变量 结束时间 = 0
            结束时间 = 指定时间("d",时长天数,end1Time1)
            
            如果(是否更新状态)
                sqlstr = 字符串格式化("update 注册码管理表 set 到期时间='%s',状态='使用中' where 注册码名称='%s'",结束时间,keyArr[i])
            否则
                sqlstr = 字符串格式化("update 注册码管理表 set 到期时间='%s' where 注册码名称='%s';",结束时间,keyArr[i])
            结束
            ret = sqlite数据库执行返回json("注册码数据库.db",sqlstr,返回数组)
        否则
            写注册码操作日志("续费注册码失败: "&keyArr[i]&" 注册码不存在")
        结束
    结束
    
    返回 真
结束


// 判断登录者是否可以验证通过
功能 效验注册码登陆的合法性(项目名称,输入机器码, regKey, token, IP="", 最后登陆时间="")
    变量 返回数组,ret,retmsg="登录失败:未知错误"
    
    变量 sqlstr = 字符串格式化("select * from 注册码管理表 where 注册码名称='%s' and 项目名称='%s'",regKey,项目名称)
    ret = sqlite数据库执行返回数组("注册码数据库.db",sqlstr,返回数组)
    写注册码操作日志("机器码: " & 输入机器码&" 注册码: " & regKey) //如果相同的机器码与注册码访问频繁，可以考虑是否有人在破解软件
    如果(数组大小(返回数组) > 0)
        // 判断注册码是否冻结了
        如果(返回数组[0]["冻结"] == "是")
            retmsg = "登录失败:注册码已经冻结"
            返回 retmsg
        结束
        
        // 判断注册码是否过期了
        如果(返回数组[0]["状态"] == "已过期")
            retmsg = "登录失败:注册码已过期"
            返回 retmsg
        结束
        
        // 判断注册码是否已经绑定了本机器
        变量 机器码 = 返回数组[0]["机器码"]
        
        // 第一次登录,也就是新卡登陆,不做过多的判断
        如果(机器码 == "")
            变量 开始时间 = 当前时间()
            变量 结束时间 = 0
            
            选择(返回数组[0]["卡类型"])
                条件 "季卡"
                结束时间 = 指定时间("m",3,开始时间)
                
                条件 "月卡"
                结束时间 = 指定时间("m",1,开始时间)
                
                条件 "周卡"
                结束时间 = 指定时间("d",7,开始时间)
                
                条件 "天卡"
                结束时间 = 指定时间("d",1,开始时间)
            结束
            
            变量 update = 字符串格式化("update 注册码管理表 set 机器码='%s',激活时间='%s',到期时间='%s',绑定='是',激活='是',状态='使用中',在线='是',IP='%s',最后登陆时间='%s',token='%s' where 注册码名称='%s'",输入机器码,开始时间,结束时间,IP,最后登陆时间,token,regKey)
            写注册码操作日志("SQL: "&update)
            ret = sqlite数据库执行返回数组("注册码数据库.db",update,返回数组)
            
            变量 min = 时间间隔("n",开始时间,结束时间)
            如果(min>0)
                retmsg = "登录成功:剩余时间=" & min & "分钟"
            否则
                sql修改注册码的状态(regKey,"已过期")
                retmsg = "登录失败:注册码已经过期"
            结束
            返回 retmsg
        结束
        
        // 机器码相同的话,表示是同一台机器使用
        如果(机器码 != "" && 机器码 == 输入机器码)  
            变量 开始时间 = 返回数组[0]["激活时间"]
            变量 结束时间 = 返回数组[0]["到期时间"]
            
            // 更新访问token值
            变量 update = 字符串格式化("update 注册码管理表 set IP='%s',在线='是',最后登陆时间='%s',token='%s' where 注册码名称='%s'",IP,最后登陆时间,token,regKey)
            写注册码操作日志("SQL: "&update)
            ret = sqlite数据库执行返回数组("注册码数据库.db",update,返回数组)
            
            变量 nowtime = 当前时间()
            变量 min = 时间间隔("n",nowtime,结束时间)
            如果(min>0)
                retmsg = "登录成功:剩余时间=" & min & "分钟"
            否则
                sql修改注册码的状态(regKey,"已过期")
                retmsg = "登录失败:注册码已经过期"
            结束
            返回 retmsg
        结束
        
        // 机器码不同的就判断是否绑定了
        如果(机器码 != "" && 机器码 != 输入机器码)  
            变量 是否绑定 = 返回数组[0]["绑定"]
            如果(是否绑定 == "是")
                retmsg = "登录失败:注册码已经绑定其他机器"
            否则
                // 更新访问token值            
                变量 update = 字符串格式化("update 注册码管理表 set 机器码='%s',绑定='是',在线='是',IP='%s',最后登陆时间='%s',token='%s' where 注册码名称='%s';",输入机器码,IP,最后登陆时间,token,regKey)
                写注册码操作日志("更换绑定机器码: "&update)
                ret = sqlite数据库执行返回数组("注册码数据库.db",update,返回数组)
                
                变量 结束时间 = 返回数组[0]["到期时间"]
                变量 nowtime = 当前时间()
                变量 min = 时间间隔("n",nowtime,结束时间)
                如果(min>0)
                    retmsg = "登录成功:剩余时间=" & min & "分钟"
                否则
                    sql修改注册码的状态(regKey,"已过期")
                    retmsg = "登录失败:注册码已经过期"
                结束
            结束
            
            返回 retmsg
        结束
    否则
        写注册码操作日志("查询失败:"&获取错误信息(1))
        retmsg = "登录失败:注册码不存在"
    结束
    
    返回 retmsg
结束

// 查询注册码使用时间
功能 sql查询注册码使用时间(输入机器码,regKey,token)
    变量 sqlstr = 字符串格式化("select * from 注册码管理表 where 注册码名称='%s' and 机器码='%s'",regKey,输入机器码)
    变量 返回数组,ret,retMsg
    ret = sqlite数据库执行返回数组("注册码数据库.db",sqlstr,返回数组)
    
    如果(数组大小(返回数组) <=0)
        retMsg = "查询失败:查询失败."
        返回 retMsg
    结束
    
    // 判断是否冻结
    如果(返回数组[0]["冻结"] == "是")
        retMsg = "查询失败:注册码已经冻结."
        返回 retMsg
    结束
    
    // 判断是否过期
    如果(返回数组[0]["状态"] == "已过期")
        retMsg = "查询失败:注册码已过期."
        返回 retMsg
    结束
    
    // 判断是否为同一个客户端访问
    如果(返回数组[0]["token"] != token)
        retMsg = "查询失败:注册码只能在一个客户端使用."
        返回 retMsg
    结束
    
    变量 开始时间 = 返回数组[0]["激活时间"]
    变量 结束时间 = 返回数组[0]["到期时间"]
    变量 nowtime = 当前时间()
    变量 min = 时间间隔("n",nowtime,结束时间)
    如果(min <= 0)
        sql修改注册码的状态(regKey,"已过期")
    结束
    
    // 最后访问时间
    sqlstr = 字符串格式化("update 注册码管理表 set 最后访问时间='%s' where 注册码名称='%s'",nowtime,regKey)
    sqlite数据库执行返回数组("注册码数据库.db",sqlstr,返回数组)
    
    retMsg = min
    返回 retMsg
结束


// 返回某个项目的注册码信息
功能 sql获取某个项目的注册码所有信息(查询条件)
    更新注册码是否过期()
    变量 sqlstr = ""
    sqlstr = "select * from 注册码管理表 " & 查询条件
    
    变量 返回数据,ret
    ret = sqlite数据库执行返回json("注册码数据库.db",sqlstr,返回数据)
    如果(!ret)
        写注册码操作日志("查询失败:"&获取错误信息(1))
        返回 ""   
    否则
        写注册码操作日志("获取所有注册码："&返回数据)
        返回 返回数据
    结束
结束

// 修改注册码的项目名称
功能 sql修改注册码的项目名称(注册码,新项目名称)
    变量 结果数据 = 数组()
    变量 keyArr = 字符串转数组(注册码)
    遍历(变量 i = 0; i < 数组大小(keyArr); i++)
        变量 sqlstr = 字符串格式化("update 注册码管理表 set 项目名称='%s' where 注册码名称='%s'",新项目名称,keyArr[i])
        变量 返回数据,ret
        ret = sqlite数据库执行返回json("注册码数据库.db",sqlstr,返回数据)
        如果(!ret)
            写注册码操作日志("sql修改注册码的项目名称失败:"&获取错误信息(1))
        否则
            写注册码操作日志("sql修改注册码的项目名称成功")
            // 记录操作日志
            写操作日志("修改注册码的项目名称",keyArr[i]&"的项目名称改为:"&新项目名称)
        结束
    结束
    
    返回 真
结束

// 修改注册码的备注
功能 sql修改注册码的备注(注册码,新备注信息)
    变量 结果数据 = 数组()
    变量 keyArr = 字符串转数组(注册码)
    遍历(变量 i = 0; i < 数组大小(keyArr); i++)
        变量 sqlstr = 字符串格式化("update 注册码管理表 set 备注='%s' where 注册码名称='%s'",新备注信息,keyArr[i])
        变量 返回数据,ret
        ret = sqlite数据库执行返回json("注册码数据库.db",sqlstr,返回数据)
        如果(!ret)
            写注册码操作日志("sql修改注册码的备注失败:"&获取错误信息(1))
        否则
            写注册码操作日志("sql修改注册码的备注成功")
            // 记录操作日志
            写操作日志("修改注册码的项目名称",keyArr[i]&"的备注改为:"&新备注信息)
        结束
    结束
    
    返回 真
结束

// 状态为: 未使用 已使用 已过期
功能 sql修改注册码的状态(注册码,状态)
    变量 sqlstr = 字符串格式化("update 注册码管理表 set 状态='%s' where 注册码名称='%s'",状态,注册码)
    变量 返回数据,ret
    ret = sqlite数据库执行返回json("注册码数据库.db",sqlstr,返回数据)
    如果(!ret)
        写注册码操作日志("修改注册码的状态失败:"&获取错误信息(1))
        返回 真
    否则
        写注册码操作日志("修改注册码的状态成功")
        返回 假
    结束
结束

功能 更新注册码是否过期()
    // 统计注册码在线的总数
    变量 当前的时间 = 当前时间()
    变量 过期判断sql语句 = "",返回数据
    过期判断sql语句 = 字符串格式化("update 注册码管理表 set 状态='已过期' where 到期时间 < '%s'",当前的时间)   
    sqlite数据库执行返回数组("注册码数据库.db",过期判断sql语句,返回数据)
    返回 0
结束

// 获取注册码相关信息  总数 + 已使用个数 + 在线个数
功能 获取注册码使用情况(项目名称)
    变量 返回数据,ret
    
    // 统计注册码总数
    变量 统计总数sql语句 = "select count(*) from 注册码管理表"
    如果(项目名称 == "全部")
        统计总数sql语句 = "select count(*) from 注册码管理表"
    否则
        统计总数sql语句 = 字符串格式化("select count(*) from 注册码管理表 where 项目名称='%s'",项目名称)
    结束    
    ret = sqlite数据库执行返回数组("注册码数据库.db",统计总数sql语句,返回数据)
    变量 总数 = 返回数据["0"]["count(*)"]
    如果(总数 <= 0)
        return ""
    结束
    
    // 统计注册码已使用的总数
    变量 统计已使用数sql语句 = "select count(*) from 注册码管理表"
    如果(项目名称 == "全部")
        统计已使用数sql语句 = "select count(*) from 注册码管理表 where 状态='使用中'"
    否则
        统计已使用数sql语句 = 字符串格式化("select count(*) from 注册码管理表 where  状态='使用中' and 项目名称='%s'",项目名称)
    结束    
    ret = sqlite数据库执行返回数组("注册码数据库.db",统计已使用数sql语句,返回数据)
    变量 已使用个数 = 返回数据["0"]["count(*)"]
    
    // 统计注册码在线的总数
    变量 当前的时间 = 当前时间()
    // 最后的访问时间间隔小于30分钟,就认为是在线
    变量 判断离线的时间 = timeadd("n",-30,当前的时间)
    变量 统计在线数sql语句 = ""
    变量 更新在线数sql语句 = ""
    
    如果(项目名称 == "全部")
        统计在线数sql语句 = 字符串格式化("select count(*) from 注册码管理表 where 最后访问时间 >'%s'",判断离线的时间)
        更新在线数sql语句 = 字符串格式化("update 注册码管理表 set 在线='否' where 最后访问时间 <'%s'",判断离线的时间)
    否则
        统计在线数sql语句 = 字符串格式化("select count(*) from 注册码管理表 where 项目名称='%s' and 最后访问时间 >'%s'",项目名称,判断离线的时间)
        更新在线数sql语句 = 字符串格式化("update 注册码管理表 set 在线='否' where 项目名称='%s' and 最后访问时间 <'%s'",项目名称,判断离线的时间)
    结束
    
    sqlite数据库执行返回数组("注册码数据库.db",更新在线数sql语句,返回数据)
    
    ret = sqlite数据库执行返回数组("注册码数据库.db",统计在线数sql语句,返回数据)
    变量 在线个数 = 返回数据["0"]["count(*)"]
    
    变量 结果 = 数组()
    结果["总数"] = 总数
    结果["已使用个数"] = 已使用个数
    结果["在线个数"] = 在线个数
    
    变量 返回json数据 = 数组转json(结果)
    写注册码操作日志("返回json数据是:"&返回json数据)
    返回 返回json数据
结束

// 获取满足条件的数据总数
功能 获取满足条件的数据总数(查询条件)
    变量 sqlstr = ""
    sqlstr = "select count(*) from 注册码管理表 " & 查询条件
    
    变量 返回数据,ret
    ret = sqlite数据库执行返回数组("注册码数据库.db",sqlstr,返回数据)
    如果(!ret && 数组大小(返回数据) <= 0 )
        写注册码操作日志("获取总数失败:"&获取错误信息(1))
        返回 ""   
    否则
        写注册码操作日志("获取满足条件的注册码总条数为："&返回数据)
    结束
    
    返回 返回数据["0"]["count(*)"]
结束

// 获取上下一页的注册码数据
功能 获取上下一页的注册码数据(查询条件)
    更新注册码是否过期()
    变量 sqlstr = ""
    sqlstr = "select * from 注册码管理表 " & 查询条件
    
    变量 返回数据,ret
    ret = sqlite数据库执行返回json("注册码数据库.db",sqlstr,返回数据)
    如果(!ret)
        写注册码操作日志("查询失败:"&获取错误信息(1))
        返回 ""   
    否则
        写注册码操作日志("执行查询上下页的SQL"&sqlstr)
        返回 返回数据    
    结束
结束