// 创建数据库,此为测试示例,所以创建数据库使用代码创建,实际项目里,不建议这样做.
// 百宝云的虚拟桌面系统里有数据库管理,推荐大家在虚拟桌面里进行数据库的创建与字段修改操作.
功能 sql创建项目键值管理表()
    变量 返回数组,ret
    ret = sqlite数据库执行返回数组("注册码数据库.db","create table IF NOT EXISTS 项目键值管理表(序号 integer primary key autoincrement,项目名称,键,值,备注)",返回数组)//创建表
    如果(!ret)
        写项目键值日志("创建表失败:"& 获取错误信息(1))
        返回 假
    否则
        返回 真
    结束
结束

// sql插入新项目键值
功能 sql插入新项目键值(项目名称,键,值)
    写项目键值日志("sql插入新项目键值")
    变量 retArray = null,sqlText    
    变量 selectStr = 字符串格式化("select * from 项目键值管理表 where 项目名称='%s' and 键='%s' and 值='%s'",项目名称,键,值)
    变量 ret = sqlite数据库执行返回数组("注册码数据库.db",selectStr,retArray)
    如果(ret && 数组大小(retArray) == 0)
        sqlText = 字符串格式化("insert into 项目键值管理表(项目名称,键,值) values('%s','%s','%s')",项目名称,键,值)    
        sqlite数据库执行返回json("注册码数据库.db",sqlText,retArray)
        
        selectStr = 字符串格式化("select * from 项目键值管理表 where 项目名称='%s' and 键='%s' and 值='%s'",项目名称,键,值)
        sqlite数据库执行返回json("注册码数据库.db",selectStr,retArray)
        写项目键值日志("添加项目键值成功:"& retArray)
        
        // 记录操作日志
        写操作日志("添加项目键值成功","项目名称【"&项目名称&"】已经添加到数据库")
        返回 retArray
    否则
        写项目键值日志("添加项目键值失败:"& 获取错误信息(1))
        返回 retArray
    结束
结束

// 删除项目名称
功能 sql删除项目键值(项目名称,键,值)
    变量 retArray = null,sqlText  
    变量 selectStr = 字符串格式化("select * from 项目键值管理表 where 项目名称='%s' and 键='%s' and 值='%s'",项目名称,键,值)
    变量 ret = sqlite数据库执行返回数组("注册码数据库.db",selectStr,retArray)
    如果(数组大小(retArray) > 0)
        sqlText = 字符串格式化("delete from 项目键值管理表 where 项目名称='%s' and 键='%s' and 值='%s'",项目名称,键,值)    
        sqlite数据库执行返回json("注册码数据库.db",sqlText,retArray)
        // 记录操作日志
        写操作日志("删除项目键值","项目名称【"&项目名称&"】键为【"&键&"】被已经被删除")
        返回 真
    否则
        // 记录操作日志
        写操作日志("删除项目键值","项目名称【"&项目名称&"】键为【"&键&"】删除失败")
        返回 假
    结束
    
结束

// 查询所有项目键值
功能 sql查询所有项目键值(查询条件)
    变量 retArray = null,sqlText = "select * from 项目键值管理表" & 查询条件
    变量 ret = sqlite数据库执行返回json("注册码数据库.db",sqlText,retArray)
    如果(ret && retArray != null)
        写项目键值日志("查询所有项目键值成功")
        返回 retArray
    否则
        写项目键值日志("查询所有项目键值失败:"& 获取错误信息(1))
        返回 retArray
    结束
结束

// 修改项目值
功能 sql修改项目值(项目名称,键,原值,新值)
    变量 retArray = null
    变量 sqlText = 字符串格式化("update 项目键值管理表 set 值='%s' where 项目名称='%s' and 键='%s' and 值='%s' ",新值,项目名称,键,原值)
    变量 ret = sqlite数据库执行返回json("注册码数据库.db", sqlText, retArray)
    如果(ret && retArray != null)
        写项目键值日志("修改项目键值成功:"& retArray)
        // 记录操作日志
        写操作日志("修改项目键值","项目名称【"&项目名称&"】的键值被修改为【"&原值&" = "&新值&"】")
        返回 "OK"
    否则
        写项目键值日志("修改项目键值失败:"& 获取错误信息(1))
        返回 "NO"
    结束
结束

// 查询所有项目键值
功能 sql查询所有项目键值的总数(查询条件)
    变量 retArray = null,sqlText = "select count(*) from 项目键值管理表" & 查询条件
    变量 ret = sqlite数据库执行返回数组("注册码数据库.db",sqlText,retArray)
    如果(ret && 数组大小(retArray) > 0 )
        写项目键值日志("查询所有项目键值的总数成功:"& retArray)
        返回 retArray["0"]["count(*)"]
    否则
        写项目键值日志("查询所有项目键值的总数失败:"& 获取错误信息(1))
        返回 retArray
    结束
结束

// 查询指定项目的键值
功能 sql查询指定项目的键值(项目名称,项目键名称)
    变量 retArray = null,sqlText = 字符串格式化("select * from 项目键值管理表 where 项目名称='%s' and 键='%s'",项目名称,项目键名称)
    变量 ret = sqlite数据库执行返回数组("注册码数据库.db",sqlText,retArray)
    如果(ret && 数组大小(retArray) > 0 )
        写项目键值日志("查询指定项目的键值:"& retArray)
        返回 retArray["0"]["值"]
    否则
        写项目键值日志("查询指定项目的键值失败:"& 获取错误信息(1))
        返回 retArray
    结束
结束
